# -*- coding: utf-8 -*-
# mod by Lululla

from __future__ import absolute_import
from . import _
from Components.config import (
    config,
    ConfigSubsection,
    ConfigSelection,
    getConfigListEntry,
    ConfigNothing,
    NoSave,
)
from Components.ConfigList import ConfigListScreen
from Components.Sources.Progress import Progress
from Tools.Downloader import downloadWithProgress
from Components.Sources.StaticText import StaticText
from Components.Label import Label
from Components.Pixmap import Pixmap
from Components.AVSwitch import AVSwitch
from Tools.Directories import fileExists
from Components.AVSwitch import AVSwitch
from Components.ActionMap import ActionMap
from Components.ConfigList import ConfigListScreen
from Components.config import configfile
from Components.Label import Label
from Components.Pixmap import Pixmap
from Components.Sources.StaticText import StaticText
from Components.config import config, ConfigOnOff
from Components.config import ConfigSubsection, getConfigListEntry
from Components.config import ConfigSelection, ConfigText
from Components.config import NoSave, ConfigNothing, ConfigYesNo
from Plugins.Plugin import PluginDescriptor
from Screens.Console import Console
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from Screens.Standby import TryQuitMainloop
from Tools.Directories import fileExists
from Tools.Directories import SCOPE_PLUGINS
from Tools.Directories import resolveFilename
from enigma import ePicLoad, loadPic, eTimer
import os
import sys
import time
import re

PY3 = sys.version_info.major >= 3
try:
    from urllib.request import Request
    from urllib.request import urlopen
except ImportError:
    from urllib2 import Request
    from urllib2 import urlopen



version = "3.7.1"

config.plugins.xDreamy = ConfigSubsection()
config.plugins.xDreamy.header = NoSave(ConfigNothing())
   
config.plugins.xDreamy.colorSelector = ConfigSelection(default='head', choices=[
    ('head', _('Default')),
    ('color1_Blue', _('Blue')),
    ('color2_Brown', _('Brown')),
    ('color3_Green', _('Green')),
    ('color4_Grey', _('Grey')),
    ('color5_Maroon', _('Maroon')),
    ('color6_Orange', _('Orange')),
    ('color7_Pink', _('Pink')),
    ('color8_Purple', _('Purple')),
    ('color9_Teal', _('Teal')),
    ('color10_Gold', _('Gold')),
    ('color11_Red', _('Red'))])
config.plugins.xDreamy.FontStyle = ConfigSelection(default='basic', choices=[
    ('basic', _('Default')),
    ('font1', _('Andalus')),
    ('font2', _('Beiruti')),
    ('font3', _('BonaNovaSC')),
    ('font4', _('Dubai')),
    ('font5', _('ElMessiri')),
    ('font6', _('Fustat')),
    ('font7', _('Lucida')),
    ('font8', _('Majalla')),
    ('font9', _('MV Boli')),
    ('font10', _('Nask')),
    ('font11', _('PlexSans')),
    ('font12', _('ReadexPro')),
    ('font13', _('Rubik')),
    ('font14', _('Tajawal')),
    ('font15', _('Zain')),
    ('font16', _('Nmsbd'))])
config.plugins.xDreamy.skinSelector = ConfigSelection(default='base', choices=[
    ('base', _('Default')),
    ('base1', _('Style2')),
    ('base2', _('Style3')),
    ('base3', _('Style4')),
    ('base4', _('Style5')),
    ('base5', _('Style6'))])
config.plugins.xDreamy.KeysStyle = ConfigSelection(default='keys', choices=[
    ('keys', _('Default')),
    ('keys1', _('Keys1')),
    ('keys2', _('Keys2')),
    ('keys3', _('Keys3')),
    ('keys4', _('Keys4')),
    ('keys5', _('Keys5')),
    ('keys6', _('Keys6'))])
config.plugins.xDreamy.InfobarStyle = ConfigSelection(default='InfoBar-1P', choices=[
    ('InfoBar-1P', _('Default')),
    ('InfoBar-2P', _('InfoBar1-2P')),
    ('InfoBar-NP', _('InfoBar1-NP')),
    ('InfoBar2-NP', _('InfoBar2-NP')),
    ('InfoBar2-1P', _('InfoBar2-1P')),
    ('InfoBar2-2P', _('InfoBar2-2P')),
    ('InfoBar2-1PW', _('InfoBar2-1PW')),
    ('InfoBar3-F1', _('InfoBar3-F1')),
    ('InfoBar3-F2', _('InfoBar3-F2')),
    ('InfoBar3-F3', _('InfoBar3-F3'))])
config.plugins.xDreamy.SecondInfobarStyle = ConfigSelection(default='SecondInfobar-2P', choices=[
    ('SecondInfobar-2P', _('Default')),
    ('SecondInfobar-NP', _('SecondInfobar-NP')),
    ('SecondInfobar-2PN', _('SecondInfobar-2PN')),
    ('SecondInfobar-2PN2', _('SecondInfobar-2PN2'))])
config.plugins.xDreamy.ChannSelector = ConfigSelection(default='CL01-MTV-1P', choices=[
    ('CL01-MTV-1P', _('Default')),
    ('CL02-MTV-2P', _('CL02-MTV-2P')),
    ('CL03-MTV-7P', _('CL03-MTV-7P')),
    ('CL04-MTV-13P', _('CL04-MTV-13P')),
    ('CL05-MTV-1P-EL', _('CL05-MTV-1P-EL')),
    ('CL06-MTV-NP-EL', _('CL06-MTV-NP-EL')),
    ('CL07-MTV-7P-N', _('CL07-MTV-7P-N')),
    ('CL08-MTV-NP-N-EL', _('CL08-MTV-NP-N-EL')),
    ('CL09-MTVL-NP', _('CL09-MTVL-NP')),
    ('CL10-MTV-NP-CLL', _('CL10-MTV-NP-CLL')),
    ('CL11-MTV-1P-CLL', _('CL11-MTV-1P-CLL'))])
config.plugins.xDreamy.EventView = ConfigSelection(default='EventView0-BD', choices=[
    ('EventView0-BD', _('Default')),
    ('EventView1-NP', _('E.View1-NP')),
    ('EventView2-1P-big', _('E.View2-1P-L')),
    ('EventView3-7P', _('E.View3-7P')),
    ('EventView4-7PBig', _('EventView4-7P-XL'))])
config.plugins.xDreamy.PluginBrowser = ConfigSelection(default='PluginBrowser', choices=[
    ('PluginBrowser', _('Default')),
    ('PluginBrowser4GHT', _('PluginBrowser4GHT')),
    ('PluginBrowser4GHM', _('PluginBrowser4GHM')),
    ('PluginBrowser4GHB', _('PluginBrowser4GHB')),
    ('PluginBrowser5GVL', _('PluginBrowser5GVL')),
    ('PluginBrowser5GVR', _('PluginBrowser5GVR'))])
config.plugins.xDreamy.VolumeBar = ConfigSelection(default='volume1', choices=[
    ('volume1', _('Default')),
    ('volume2', _('volume2')),
    ('volume3', _('volume3')),
    ('volume4', _('volume4')),
    ('volume5', _('volume5'))])
config.plugins.xDreamy.VirtualKeyboard = ConfigSelection(default='VirtualKeyBoard', choices=[
    ('VirtualKeyBoard', _('Default')),
    ('VirtualKeyBoardor', _('V.Keyboardor')),
    ('VirtualKeyBoard1', _('V.Keyboard1')),
    ('VirtualKeyBoard2', _('V.Keyboard2'))])
config.plugins.xDreamy.NewVirtualKeyboard = ConfigSelection(default='NewVirtualKeyBoard', choices=[
    ('NewVirtualKeyBoard', _('Default')),
    ('NewVirtualKeyBoard1', _('NV.KeyBoard1')),
    ('NewVirtualKeyBoard2', _('NV.KeyBoard2')),
    ('NewVirtualKeyBoard3', _('NV.KeyBoard3')),
    ('NewVirtualKeyBoard4', _('NV.KeyBoard4'))])
config.plugins.xDreamy.HistoryZapSelector = ConfigSelection(default='HistoryZapSelector', choices=[
    ('HistoryZapSelector', _('Default')),
    ('HistoryZapSelector1', _('HistoryZap1-NP')),
    ('HistoryZapSelector2', _('HistoryZap2-NP'))])
config.plugins.xDreamy.EPGMultiSelection = ConfigSelection(default='EPGMultiSelection', choices=[
    ('EPGMultiSelection', _('Default')),
    ('EPGMultiSelection1', _('EPGMultiSelection1'))])
config.plugins.xDreamy.E2Player = ConfigSelection(default='E2Player', choices=[
    ('E2Player', _('Default')),
    ('E2Player1', _('E2Player1')),
    ('E2Player2', _('E2Player2'))])
config.plugins.xDreamy.EnhancedMovieCenter = ConfigSelection(default='EnhancedMovieCenter', choices=[
    ('EnhancedMovieCenter', _('Default')),
    ('EnhancedMovieCenter1', _('E.MovieCenter1')),
    ('EnhancedMovieCenter2', _('E.MovieCenter2')),
    ('EnhancedMovieCenter3', _('E.MovieCenter3'))])
config.plugins.xDreamy.ChannelListBackground = ConfigSelection(default='Background', choices=[
    ('Background', _('Default')),
    ('Background1', _('Background1')),
    ('Background2', _('Background2')),
    ('Background3', _('Background3')),
    ('Background4', _('Background4')),
    ('Background5', _('Background5')),
    ('Background6', _('Background6')),
    ('Background7', _('Background7')),
    ('Background8', _('Background8')),
    ('Background9', _('Background9')),
    ('Background10', _('Background10')),
    ('Background11', _('Background11')),
    ('Background12', _('Background12')),
    ('Background13', _('Background13')),
    ('Background14', _('Background14')),
    ('Background15', _('Background15'))])
config.plugins.xDreamy.TurnOff = ConfigSelection(default='Background', choices=[
    ('Background', _('Default')),
    ('Background1', _('Background1')),
    ('Background2', _('Background2')),
    ('Background3', _('Background3')),
    ('Background4', _('Background4')),
    ('Background5', _('Background5')),
    ('Background6', _('Background6')),
    ('Background7', _('Background7')),
    ('Background8', _('Background8')),
    ('Background9', _('Background9')),
    ('Background10', _('Background10')),
    ('Background11', _('Background11')),
    ('Background12', _('Background12')),
    ('Background13', _('Background13')),
    ('Background14', _('Background14')),
    ('Background15', _('Background15'))])
config.plugins.xDreamy.WeatherSource = ConfigSelection(default='OAWeatherPlugin', choices=[
    ('OAWeatherPlugin', _('Default-OAWeatherPlugin')),
    ('MSNWeatherPlugin', _('MSNWeatherPlugin'))])
config.plugins.xDreamy.BitrateSource = ConfigSelection(default='BitratePlugin', choices=[
    ('BitratePlugin', _('Default-BitratePlugin')),
    ('BitrateRenderer', _('Bitrate Renderer'))])


def Plugins(**kwargs):
    return PluginDescriptor(name='XDREAMY', description=_('Customization tool for XDREAMY Skin'), where=PluginDescriptor.WHERE_PLUGINMENU, icon='plugin.png', fnc=main)

def main(session, **kwargs):
    session.open(xDreamySetup)

def _space(self):
    self.list.append(getConfigListEntry(" ", config.xDreamy.fake, False))
    
def fakeconfig(name):
    retr = [['OZETA SKIN PARTS SETUP']]
    for nname in retr:
        if nname[0] in str(name):
            return True
    return False

class xDreamySetup(ConfigListScreen, Screen):
    skin = '<screen name="xDreamySetup" position="center,center" size="1000,640" title="XDREAMY skin customization plugin">\n\t\t  <eLabel font="Regular; 24" foregroundColor="#00ff4A3C" halign="center" position="20,598" size="120,26" text="Cancel" />\n\t\t  <eLabel font="Regular; 24" foregroundColor="#0056C856" halign="center" position="220,598" size="120,26" text="Save" />\n\t\t  <widget name="Preview" position="997,690" size="498, 280" zPosition="1" />\n\t\t <widget name="config" font="Regular; 24" itemHeight="40" position="5,5" scrollbarMode="showOnDemand" size="990,550" />\n\t\t\n\t\t  </screen>'

    def __init__(self, session):
        self.version = '.xDreamy'
        Screen.__init__(self, session)
        self.session = session
        self.skinFile = '/usr/share/enigma2/xDreamy/skin.xml'
        self.previewFiles = '/usr/share/enigma2/xDreamy/sample/'
        self['Preview'] = Pixmap()
        self.editListEntry = None
        self.list = []
        list = []
        
        # Skin Layouts
        list.append(getConfigListEntry("\\c00289496 ---------------------   GENERAL SKIN SETUP   ---------------------- ")) #Header
        list.append(getConfigListEntry(_('Skin Style:'), config.plugins.xDreamy.skinSelector))
        list.append(getConfigListEntry(_('Color Style:'), config.plugins.xDreamy.colorSelector))
        list.append(getConfigListEntry(_('Font Style:'), config.plugins.xDreamy.FontStyle))
        list.append(getConfigListEntry(_('Keys Style:'), config.plugins.xDreamy.KeysStyle))

        # Skin Screens
        list.append(getConfigListEntry("\\c00289496 ---------------------   BASIC SKIN SCREENS   ---------------------- ")) #Header
        list.append(getConfigListEntry(_('InfoBar Style:'), config.plugins.xDreamy.InfobarStyle))
        list.append(getConfigListEntry(_('SecondInfobar Style:'), config.plugins.xDreamy.SecondInfobarStyle))
        list.append(getConfigListEntry(_('ChannelSelection Style:'), config.plugins.xDreamy.ChannSelector))
        list.append(getConfigListEntry(_('EventView Style:'), config.plugins.xDreamy.EventView))
        list.append(getConfigListEntry(_('VolumeBar Style:'), config.plugins.xDreamy.VolumeBar))
        list.append(getConfigListEntry(_('PluginBrowser Style:'), config.plugins.xDreamy.PluginBrowser))
        list.append(getConfigListEntry(_('VirtualKeyboard Style:'), config.plugins.xDreamy.VirtualKeyboard))
        list.append(getConfigListEntry(_('HistoryZapSelector Style:'), config.plugins.xDreamy.HistoryZapSelector))

        # Plugin Screens
        list.append(getConfigListEntry("\\c00289496 --------------------   USER PLUGINS SCREENS   --------------------- ")) #Header
        list.append(getConfigListEntry(_('NewVirtualKeyboard Style:'), config.plugins.xDreamy.NewVirtualKeyboard))
        list.append(getConfigListEntry(_('EPGMultiSelection Style:'), config.plugins.xDreamy.EPGMultiSelection))
        list.append(getConfigListEntry(_('E2Player Style:'), config.plugins.xDreamy.E2Player))
        list.append(getConfigListEntry(_('EnhancedMovieCenter Style:'), config.plugins.xDreamy.EnhancedMovieCenter))

        # Wallpapers
        list.append(getConfigListEntry("\\c00289496 --------------------   USER SKIN WALLPAPERS   --------------------- ")) #Header
        list.append(getConfigListEntry(_('ChannelListBackground Style:'), config.plugins.xDreamy.ChannelListBackground))
        list.append(getConfigListEntry(_('ShutDown Style:'), config.plugins.xDreamy.TurnOff))

        # Weather
        list.append(getConfigListEntry("\\c00289496 ----------------------   USER DATA SOURCE   ----------------------- ")) #Header
        list.append(getConfigListEntry(_('Weather Source:'), config.plugins.xDreamy.WeatherSource))
        list.append(getConfigListEntry(_('Bitrate Source:'), config.plugins.xDreamy.BitrateSource))

        ConfigListScreen.__init__(self, list)
        self['actions'] = ActionMap(['OkCancelActions',
                                     'DirectionActions',
                                     'InputActions',
                                     'ColorActions'], {'left': self.keyLeft,
                                                       'down': self.keyDown,
                                                       'up': self.keyUp,
                                                       'right': self.keyRight,
                                                       'red': self.keyExit,
                                                       'green': self.keySave,
                                                       'yellow': self.checkforUpdate,
                                                       'blue': self.info,
                                                       'cancel': self.keyExit}, -1)

        self.PicLoad = ePicLoad()
        self.Scale = AVSwitch().getFramebufferScale()
        try:
            self.PicLoad.PictureData.get().append(self.DecodePicture)
        except:
            self.PicLoad_conn = self.PicLoad.PictureData.connect(self.DecodePicture)
        self.timerx = eTimer()
        if fileExists('/var/lib/dpkg/status'):
            self.timerx_conn = self.timerx.timeout.connect(self.checkforUpdate)
        else:
            self.timerx.callback.append(self.checkforUpdate)
        self.timerx.start(1000, True)
        self.onLayoutFinish.append(self.UpdateComponents)
        
    def GetPicturePath(self):
        try:
            returnValue = self['config'].getCurrent()[1].value
            path = '/usr/share/enigma2/xDreamy/screens/' + returnValue + '.png'
            if fileExists(path):
                return path
            else:
                return '/usr/share/enigma2/xDreamy/screens/default.png'
        except:
            return '/usr/share/enigma2/xDreamy/screens/default.png'

    def UpdatePicture(self):
        # Usa sempre connect() per collegare la funzione callback
        try:
            self.PicLoad.PictureData.connect(self.DecodePicture)
        except:
            self.PicLoad.PictureData.get().append(self.DecodePicture)
        self.onLayoutFinish.append(self.ShowPicture)

    def ShowPicture(self, data=None):
        if self["Preview"].instance:
            width = 610
            height = 340
            self.PicLoad.setPara([width, height, self.Scale[0], self.Scale[1], 0, 1, "ff000000"])
            # startDecode non richiede la creazione di un nuovo ePicLoad
            if self.PicLoad.startDecode(self.GetPicturePath()):
                # Non è necessario ricreare PicLoad qui se non ci sono motivi specifici
                pass

    def DecodePicture(self, PicInfo=None):
        ptr = self.PicLoad.getData()
        if ptr is not None:
            self["Preview"].instance.setPixmap(ptr)
            self["Preview"].instance.show()
        return

    def UpdateComponents(self):
        self.UpdatePicture()

    def info(self):
        aboutbox = self.session.open(MessageBox, _('Setup xDreamy for xDreamy v.%s') % version, MessageBox.TYPE_INFO)
        aboutbox.setTitle(_('Info...'))

    def keyLeft(self):
        ConfigListScreen.keyLeft(self)
        self.ShowPicture()

    def keyRight(self):
        ConfigListScreen.keyRight(self)
        self.ShowPicture()

    def keyDown(self):
        self['config'].instance.moveSelection(self['config'].instance.moveDown)
        self.ShowPicture()

    def keyUp(self):
        self['config'].instance.moveSelection(self['config'].instance.moveUp)
        self.ShowPicture()

    # def keySave(self):
        # if not fileExists(self.skinFile + self.version):
            # for x in self['config'].list:
                # x[1].cancel()

            # self.close()
            # return
        # for x in self['config'].list:
            # x[1].save()

        # try:
            # skin_lines = []
            # head_file = self.previewFiles + 'head-' + config.plugins.xDreamy.colorSelector.value + '.xml'
            # skFile = open(head_file, 'r')
            # head_lines = skFile.readlines()
            # skFile.close()
            # for x in head_lines:
                # skin_lines.append(x)

            # font_file = self.previewFiles + 'font-' + config.plugins.xDreamy.FontStyle.value + '.xml'
            # skFile = open(font_file, 'r')
            # font_lines = skFile.readlines()
            # skFile.close()
            # for x in font_lines:
                # skin_lines.append(x)

            # font_file = self.previewFiles + 'keys-' + config.plugins.xDreamy.KeysStyle.value + '.xml'
            # skFile = open(font_file, 'r')
            # font_lines = skFile.readlines()
            # skFile.close()
            # for x in font_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'infobar-' + config.plugins.xDreamy.InfobarStyle.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'secondinfobar-' + config.plugins.xDreamy.SecondInfobarStyle.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'channellist-' + config.plugins.xDreamy.ChannSelector.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'CLB-' + config.plugins.xDreamy.ChannelListBackground.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'CLB1-' + config.plugins.xDreamy.TurnOff.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'eventview-' + config.plugins.xDreamy.EventView.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'vol-' + config.plugins.xDreamy.VolumeBar.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'VKB-' + config.plugins.xDreamy.VirtualKeyboard.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'NVKB-' + config.plugins.xDreamy.NewVirtualKeyboard.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'PB-' + config.plugins.xDreamy.PluginBrowser.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'HZS-' + config.plugins.xDreamy.HistoryZapSelector.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'EPG-' + config.plugins.xDreamy.EPGMultiSelection.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'E2Player-' + config.plugins.xDreamy.E2Player.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'EMC-' + config.plugins.xDreamy.EnhancedMovieCenter.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'WS-' + config.plugins.xDreamy.WeatherSource.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # skn_file = self.previewFiles + 'BS-' + config.plugins.xDreamy.BitrateSource.value + '.xml'
            # skFile = open(skn_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # base_file = self.previewFiles + 'base.xml'
            # if config.plugins.xDreamy.skinSelector.value == 'base1':
                # base_file = self.previewFiles + 'base1.xml'
            # if config.plugins.xDreamy.skinSelector.value == 'base2':
                # base_file = self.previewFiles + 'base2.xml'
            # if config.plugins.xDreamy.skinSelector.value == 'base3':
                # base_file = self.previewFiles + 'base3.xml'
            # if config.plugins.xDreamy.skinSelector.value == 'base4':
                # base_file = self.previewFiles + 'base4.xml'
            # if config.plugins.xDreamy.skinSelector.value == 'base5':
                # base_file = self.previewFiles + 'base5.xml'
            # if config.plugins.xDreamy.skinSelector.value == 'base':
                # base_file = self.previewFiles + 'base.xml'
            # skFile = open(base_file, 'r')
            # file_lines = skFile.readlines()
            # skFile.close()
            # for x in file_lines:
                # skin_lines.append(x)

            # xFile = open(self.skinFile, 'w')
            # for xx in skin_lines:
                # xFile.writelines(xx)

            # xFile.close()
        # except:
            # self.session.open(MessageBox, _('Error by processing the skin file !!!'), MessageBox.TYPE_ERROR)
        # restartbox = self.session.openWithCallback(self.restartGUI, MessageBox, _('GUI needs a restart to apply a new skin.\nDo you want to Restart the GUI now?'), MessageBox.TYPE_YESNO)
        # restartbox.setTitle(_('Restart GUI now?'))


    def keySave(self):
        # Verifica se il file della skin esiste
        if not fileExists(self.skinFile + self.version):
            for x in self['config'].list:
                x[1].cancel()
            self.close()
            return
        
        # Salva la configurazione corrente
        for x in self['config'].list:
            x[1].save()

        try:
            skin_lines = []
            # Definisci i percorsi dei file delle skin
            skin_file_paths = [
                f'head-{config.plugins.xDreamy.colorSelector.value}.xml',
                f'font-{config.plugins.xDreamy.FontStyle.value}.xml',
                f'keys-{config.plugins.xDreamy.KeysStyle.value}.xml',
                f'infobar-{config.plugins.xDreamy.InfobarStyle.value}.xml',
                f'secondinfobar-{config.plugins.xDreamy.SecondInfobarStyle.value}.xml',
                f'CHL-{config.plugins.xDreamy.ChannSelector.value}.xml',
                f'CLB-{config.plugins.xDreamy.ChannelListBackground.value}.xml',
                f'CLB1-{config.plugins.xDreamy.TurnOff.value}.xml',
                f'eventview-{config.plugins.xDreamy.EventView.value}.xml',
                f'vol-{config.plugins.xDreamy.VolumeBar.value}.xml',
                f'VKB-{config.plugins.xDreamy.VirtualKeyboard.value}.xml',
                f'NVKB-{config.plugins.xDreamy.NewVirtualKeyboard.value}.xml',
                f'PB-{config.plugins.xDreamy.PluginBrowser.value}.xml',
                f'HZS-{config.plugins.xDreamy.HistoryZapSelector.value}.xml',
                f'EPG-{config.plugins.xDreamy.EPGMultiSelection.value}.xml',
                f'E2Player-{config.plugins.xDreamy.E2Player.value}.xml',
                f'EMC-{config.plugins.xDreamy.EnhancedMovieCenter.value}.xml',
                f'WS-{config.plugins.xDreamy.WeatherSource.value}.xml',
                f'BS-{config.plugins.xDreamy.BitrateSource.value}.xml'
            ]

            # Carica i contenuti dai file specificati
            for file_name in skin_file_paths:
                file_path = os.path.join(self.previewFiles, file_name)
                if os.path.isfile(file_path):  # Controlla se il file esiste
                    with open(file_path, 'r') as skFile:
                        skin_lines.extend(skFile.readlines())

            # Determina il file base in base alla selezione della skin
            base_file_name = 'base.xml'  # Valore di default
            if config.plugins.xDreamy.skinSelector.value in ['base1', 'base2', 'base3', 'base4', 'base5']:
                base_file_name = f'base{config.plugins.xDreamy.skinSelector.value[-1]}.xml'
            
            base_file_path = os.path.join(self.previewFiles, base_file_name)
            if os.path.isfile(base_file_path):
                with open(base_file_path, 'r') as skFile:
                    skin_lines.extend(skFile.readlines())

            # Scrivi tutte le linee raccolte nel file di skin
            with open(self.skinFile, 'w') as xFile:
                xFile.writelines(skin_lines)

        except Exception as e:  # Cattura delle eccezioni specifiche
            self.session.open(MessageBox, _('Error by processing the skin file !!!') + str(e), MessageBox.TYPE_ERROR)

        restartbox = self.session.openWithCallback(self.restartGUI, MessageBox, _('GUI needs a restart to apply a new skin.\nDo you want to Restart the GUI now?'), MessageBox.TYPE_YESNO)
        restartbox.setTitle(_('Restart GUI now?'))

    def restartGUI(self, answer):
        if answer is True:
            self.session.open(TryQuitMainloop, 3)
        else:
            self.close()

    def checkforUpdate(self):
        try:
            fp = ''
            destr = '/tmp/xDreamyv.txt'
            req = Request('https://raw.githubusercontent.com/Insprion80/Skins/main/xDreamy/xDreamyv.txt')
            req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/124.0.0.0 Safari/537.36')
            fp = urlopen(req)
            fp = fp.read().decode('utf-8')
            print('fp read:', fp)
            with open(destr, 'w') as f:
                f.write(str(fp))  # .decode("utf-8"))
                f.seek(0)
                f.close()
            if os.path.exists(destr):
                with open(destr, 'r') as cc:
                    s1 = cc.readline()  # .decode("utf-8")
                    vers = s1.split('#')[0]
                    url = s1.split('#')[1]
                    version_server = vers.strip()
                    self.updateurl = url.strip()
                    cc.close()
                    if str(version_server) == str(version):
                        message = '%s %s\n%s %s\n\n%s' % (_('Server version:'),
                                                          version_server,
                                                          _('Version installed:'),
                                                          version,
                                                          _('Congratulation, You have the last version of XDREAMY!'))
                    elif version_server > version:
                        message = '%s %s\n%s %s\n\n%s' % (_('Server version:'),
                                                          version_server,
                                                          _('Version installed:'),
                                                          version,
                                                          _('The update is available!\n\nDo you want to run the update now?'))
                        self.session.openWithCallback(self.update, MessageBox, message, MessageBox.TYPE_YESNO)
                    else:
                        self.session.open(MessageBox, _('You have version %s!!!') % version, MessageBox.TYPE_ERROR)
        except Exception as e:
            print('error: ', str(e))

    def update(self, answer):
        if answer is True:
            self.session.open(xDreamyUpdater, self.updateurl)
        else:
            return

    def keyExit(self):
        for x in self['config'].list:
            x[1].cancel()
        self.close()


class xDreamyUpdater(Screen):

    def __init__(self, session, updateurl):
        self.session = session
        skin = '''
                <screen name="xDreamyUpdater" position="center,center" size="840,260" flags="wfBorder" backgroundColor="background">
                    <widget name="status" position="20,10" size="800,70" transparent="1" font="Regular; 40" foregroundColor="foreground" backgroundColor="background" valign="center" halign="left" noWrap="1" />
                    <widget source="progress" render="Progress" position="20,120" size="800,20" transparent="1" borderWidth="0" foregroundColor="white" backgroundColor="background" />
                    <widget source="progresstext" render="Label" position="209,164" zPosition="2" font="Regular; 28" halign="center" transparent="1" size="400,70" foregroundColor="foreground" backgroundColor="background" />
                </screen>
                '''
        self.skin = skin
        Screen.__init__(self, session)
        self.updateurl = updateurl
        print('self.updateurl', self.updateurl)
        self['status'] = Label()
        self['progress'] = Progress()
        self['progresstext'] = StaticText()
        self.icount = 0
        self.downloading = False
        self.last_recvbytes = 0
        self.error_message = None
        self.download = None
        self.aborted = False
        self.startUpdate()

    def startUpdate(self):
        self['status'].setText(_('Downloading XDREAMY Skin...'))
        self.dlfile = '/tmp/xDreamy.ipk'
        print('self.dlfile', self.dlfile)
        self.download = downloadWithProgress(self.updateurl, self.dlfile)
        self.download.addProgress(self.downloadProgress)
        self.download.start().addCallback(self.downloadFinished).addErrback(self.downloadFailed)

    def downloadFinished(self, string=''):
        self['status'].setText(_('Installing updates please waite!'))
        os.system('opkg install --force-reinstall --force-overwrite /tmp/xDreamy.ipk')
        os.system('sync')
        os.system('rm -r /tmp/xDreamy.ipk')
        os.system('sync')
        restartbox = self.session.openWithCallback(self.restartGUI, MessageBox, _('XDREAMY update was done!!!\nDo you want to restart the GUI now?'), MessageBox.TYPE_YESNO)
        restartbox.setTitle(_('Restart GUI now?'))

    def downloadFailed(self, failure_instance=None, error_message=''):
        text = _('Error downloading files!')
        if error_message == '' and failure_instance is not None:
            error_message = failure_instance.getErrorMessage()
            text += ': ' + error_message
        self['status'].setText(text)
        return

    def downloadProgress(self, recvbytes, totalbytes):
        self['status'].setText(_('Download in progress...'))
        self['progress'].value = int(100 * self.last_recvbytes / float(totalbytes))
        self['progresstext'].text = '%d of %d kBytes (%.2f%%)' % (self.last_recvbytes / 1024, totalbytes / 1024, 100 * self.last_recvbytes / float(totalbytes))
        self.last_recvbytes = recvbytes

    def restartGUI(self, answer):
        if answer is True:
            self.session.open(TryQuitMainloop, 3)
        else:
            self.close()
